#ifndef UTILITIEC_FIXEDBUFFER_H
#define UTILITIEC_FIXEDBUFFER_H

#include "../allocator-interface/allocator-interface.h"

typedef struct FixedBuffer_s {
	void* memory;
	size_t reserved;
	size_t length;
} FixedBuffer;

int FixedBuffer_Create(FixedBuffer* target, size_t size, allocator_t* allocator);
void FixedBuffer_Destroy(FixedBuffer* buffer, allocator_t* allocator);

void* FixedBuffer_GetHead(FixedBuffer* buffer);
size_t FixedBuffer_GetRemaining(FixedBuffer* buffer);

int FixedBuffer_DiscardTail(FixedBuffer* buffer, size_t length);

int FixedBuffer_Rewind(FixedBuffer* buffer, size_t by);
int FixedBuffer_Advance(FixedBuffer* buffer, size_t by);

int FixedBuffer_Reset(FixedBuffer* buffer);

#endif
